'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 12 November 2012 at 8:31:22 pm'!

!Morph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:01'!
ensureSlotWidth: width
"Special morphs that have a slot for others to go into may respond to this."

	^ self.! !

!Morph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 20:48'!
fixBlockOrArgLayout
	"Specialized morphs need to adjust their layout.  By default, this does nothing."
	
	^ self.! !

!Morph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:12'!
morphEndsLine
"Override this if your block/arg morph starts a new line when laid out."

	^ false.! !

!Morph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:12'!
morphStartsNewLine
"Override this if your block/arg morph starts a new line when laid out."

	^ false.! !

!Morph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:05'!
paddedHeightWhenPlacedAt: place
"How heigh is this morph when placed as the nth element,
along a line of elements in a command block?"

	^ self height.! !

!Morph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:45'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	^ self.! !


!ArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 20:51'!
fixBlockOrArgLayout
	"This type of morph needs to fix its argument layout"

	^ self fixArgLayout.
! !


!BlockMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 20:50'!
fixBlockOrArgLayout
	"This type of morph needs to fix its block layout"

	^ self fixBlockLayout.
! !


!CommandBlockMorph methodsFor: 'private' stamp: 'CWB 11/9/2012 22:27'!
fixBlockLayout
	"Update the positions of my submorphs."

	self fixBlockLayoutWrapNew.! !

!CommandBlockMorph methodsFor: 'byob' stamp: 'CWB 11/9/2012 16:35'!
fixBlockLayoutWrap
	"Update the positions of my submorphs."

	| parts lines line h x y minXForArgs nextB w space left maxX maxHeight mh |

	(self isCustomBlock and: [self isTemplate]) ifTrue: [^ self fixBlockLayoutNoWrap].
	blockLayoutNeeded ifFalse: [^ self].

	cachedForm _ nil.
	cachedFeedbackForm _ nil.

	parts _ self nonControlFlowSubmorphs.
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left + 5.
	left _ x.
	maxX _ x.
	minXForArgs _ self left.
	space _ 4.

	parts do: [:m |
	((m isKindOf: CArgSlotMorph) or: [(m isKindOf: CReporterSlotMorph) or: [(m isKindOf: MultiArgMorph) and: [m isWrapping]]])
		ifTrue: [ 
			line isEmpty ifFalse: [
				lines add: line].
			m left: "self" left.
			lines add: (OrderedCollection with: m).
			(m isKindOf: MultiArgMorph)
				ifTrue: [m fixArgLayout]
				ifFalse: [m fixBlockLayout].
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
				ifTrue: [m width: 40].
			line _ OrderedCollection new.
			maxX _ maxX max: left + m width.
			x _ left ]
		ifFalse: [
			x - left > self wrapWidth ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left].
			(m isKindOf: BlockMorph) ifTrue: [m fixBlockLayout].
			(m isKindOf: ArgMorph) ifTrue: [m fixArgLayout].
			(m isKindOf: StringMorph)
				ifTrue: [m color: self labelColor]
				ifFalse: [x _ x max: minXForArgs].

			m left: x.
			(m fullBounds right - left > 400 and: [line isEmpty not])
				ifTrue: [
					lines add: line.
					line _ OrderedCollection new.
					m left: left.
					line add: m.
					x _ left]
				ifFalse: [ line add: m].
				x _ x + m fullBounds width + space.
			maxX _ maxX max: x]].
	x = left ifFalse: [
		lines add: line].
	w _ maxX - self left max: 37.

	"distribute lines vertically"

	space _ 2.
	y _ self top + 2 "4" "space".
	lines do: [:eachLine |
		maxHeight _ 14.
		eachLine do: [:m |
			((m isKindOf: ReporterBlockMorph)
			and: [m isBlockTemplate 
			or: [((m isKindOf: CArgSlotMorph) or: [m isKindOf: OSlotMorph]) and: [m isEmptySlot not]]])
				ifTrue: [ m == eachLine first
					ifTrue: [mh _  m height + 10]
					ifFalse: [mh _ m height + 5]]
				ifFalse: [ ((m isKindOf: CArgSlotMorph) or: [m isKindOf: OSlotMorph])
					ifTrue: [mh _ m height + 5]
					ifFalse: [mh _ m height]].
			maxHeight _ mh max: maxHeight.
			((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph]) ifTrue: [
				maxHeight _ m height - 4]].
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2) + 1].
		y _ y + maxHeight + space].

	"adjust CArgSlots"

	parts do: [:m |
		((m isKindOf: CArgSlotMorph) or: [m isKindOf: CReporterSlotMorph])
			ifTrue: [m width: w - 5]].

	self isStop
		ifTrue: [h _ y - self top + space]
		ifFalse: [h _ y - self top + space + 4.].

	parts size > 0 ifTrue: [
		((parts last isKindOf: CArgSlotMorph) or: [(parts last isKindOf: CReporterSlotMorph)]) ifTrue: [
			h _ h + space + 5]].
	
	self extent: w @ h.

	"adjust Multi-CArgSlots"

	parts do: [:m | (m isKindOf: MultiArgMorph)
		ifTrue: [m loopsWidth: w - 5]].

	(nextB _ self nextBlock) ifNotNil: [
		nextB position: self left@(self bottom - 4).
		nextB fixBlockLayout].
! !

!CommandBlockMorph methodsFor: 'byob' stamp: 'CWB 11/12/2012 20:30'!
fixBlockLayoutWrapNew

	"Updates the position of submorphs, by forming them into lines and wrapping them."

	| parts lines line h x y nextB w space left maxX maxHeight mh minimumAllowableWidth placeOnNextLine vTopSpace vInnerSpace vBottomSpace extraHSpace vOffset |

	(self isCustomBlock and: [self isTemplate]) ifTrue: [^ self fixBlockLayoutNoWrap].
	blockLayoutNeeded ifFalse: [^ self].

	cachedForm _ nil.
	cachedFeedbackForm _ nil.
 
	parts _ self nonControlFlowSubmorphs.
	parts isEmpty ifTrue: [^self].
	lines _ OrderedCollection new.


	"distribute parts horizontally and cut up into lines"

	line _ OrderedCollection new.
	x _ self left + 5.
	left _ x.
	maxX _ x.
	space _ 4.
	placeOnNextLine _ false.
	minimumAllowableWidth _ 37.
	extraHSpace _ 0.	"horizontal space added for blocks with round or angled edges"

	vTopSpace _ 0.	"vertical padding"
	vInnerSpace _ 2.
	vBottomSpace _ 0. 
	vOffset _ 0.	"offset when vertically centering elements"

	self isReporter ifTrue: [
		vOffset _ 3.
	] ifFalse: [
		vTopSpace _ 3.
		vBottomSpace _ 1.
	].
	


	parts do: [:m |

		"Position the next block, as though it will fit here."
		m left: x.
		m fixBlockOrArgLayout.
		(m isKindOf: StringMorph) ifTrue: [m color: self labelColor].
		m ensureSlotWidth: 40.

		line isEmpty ifTrue: [
			"Add this morph, whether it fits nicely or not."
			line add: m.
		] ifFalse: [
			"This isn't the only item on the line."

			"Should it be wrapped to the next line?"
			(m fullBounds right - left > self wrapWidth) ifTrue: [ placeOnNextLine _ true ].

			"Does it request special placement?"
			m morphStartsNewLine ifTrue: [ placeOnNextLine _ true ].

			placeOnNextLine ifTrue: [
				lines add: line.
				line _ OrderedCollection new.
				x _ left.	
	
				"Place the block again"
				m left: x.
				m fixBlockOrArgLayout.
				
				placeOnNextLine _ false.
			].
			line add: m.
		].
		"Position for next block"
		x _ x + m fullBounds width + space.
		maxX _ maxX max: x.

		"Does this one have special spacing requirements?"
		m morphEndsLine ifTrue: [ placeOnNextLine _ true ].
	].

	line isEmpty ifFalse: [ lines add: line ].
		
	"Determine the width"
	w _ (maxX - self left) max: minimumAllowableWidth.



	"distribute lines vertically"

	y _ self top + vTopSpace.

	lines do: [:eachLine |
		maxHeight _ 0.
		eachLine doWithIndex: [:m :i |
			mh _ m paddedHeightWhenPlacedAt: i.
			maxHeight _ mh max: maxHeight.
		].

		"center elements vertically within the line they are found in."
		eachLine do: [:m |
			m top: y + (maxHeight - m height // 2) + vOffset.
		].
		y _ y + maxHeight + vInnerSpace.
	].

	"Add space for tab on the bottom"
	h _ y - self top + vBottomSpace.
	self isBlockMorph ifTrue: [
 		self isStopOrForever ifFalse: [ h _ h + 4 ].
	].

	"adjust width to accomodate round or angled sides"
	self isReporter ifTrue: [
		self isBooleanReporter ifTrue: [
			extraHSpace _ h // 2 - 6.	"angled sides"	"was // 3, seems like too much"
		] ifFalse: [
			extraHSpace _ h // 2 - 8.	"rounded sides"
		].
		parts do: [:m | m left: m left + extraHSpace].
 		w _ w + (extraHSpace * 2).

		self height: h.
		self stackNestedReporterBlocksFor: lines.
	] ifFalse: [ self extent: w @ h. ].

	"Adjust CArgSlots and Multi-CArgSlots to fit."
	parts do: [:m | m parentsFinalLineWidth: (w - (extraHSpace * 2)) ].

	(nextB _ self nextBlock) ifNotNil: [
		nextB position: self left@(self bottom - 4).
		nextB fixBlockLayout].

	(self ownerThatIsA: ScratchBlockPaletteMorph) ifNotNil: [
		(self ownerThatIsA: ScratchBlockPaletteMorph) fixLayout].	 	
! !

!CommandBlockMorph methodsFor: 'byob' stamp: 'CWB 11/12/2012 14:16'!
notBooleanWithNumericChild: childReporter
	"True if the childReporter isn't numeric and we are boolean. 
	(Used for laying out morphs)."

	^ (self isBooleanReporter and: [childReporter isBooleanReporter not]) not.! !

!CommandBlockMorph methodsFor: 'byob' stamp: 'CWB 11/12/2012 20:24'!
stackNestedReporterBlocksFor: lines

	"Stack nested reporter blocks more efficiently"

		| xAdjust maxX |

		self isBooleanReporter ifTrue: [xAdjust _ 2] ifFalse: [xAdjust _ 0].
		maxX _ self left + 5.
		
		lines do: [:line |
			| offset firstElem lastElem |
			firstElem _ line first.
			((firstElem respondsTo: #bodyLeft) and: [self notBooleanWithNumericChild: firstElem])
				ifTrue: [ offset _ firstElem bodyLeft - self bodyLeft]
				ifFalse: [ offset _ firstElem left - self bodyLeft].
				line do: [:m | m left: m left - offset + xAdjust ].
	
			lastElem _ line last.
			((lastElem respondsTo: #bodyRight)  and: [self notBooleanWithNumericChild: firstElem])
				ifTrue: [maxX _ maxX max: lastElem bodyRight]
				ifFalse: [maxX _ maxX max: lastElem right]
		].
		self bodyRight: maxX + xAdjust.
! !


!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:15'!
morphEndsLine
"This morph should be the only one on its line (not counting children) if it is wrapping."

	^ self isWrapping.! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:15'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children) if it is wrapping."

	^ self isWrapping.! !

!MultiArgMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:46'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self loopsWidth: linewidth - 5.! !


!ReporterBlockMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 11:26'!
paddedHeightWhenPlacedAt: place
"How heigh is this morph when placed as the nth element,
along a line of elements in a command block?"

	| h |

	h _ super paddedHeightWhenPlacedAt: place.

	self isBlockTemplate ifTrue: [
		(place = 1) ifTrue: [ ^ h + 10 ].
		^ h + 5.
	].
	^ h.
! !


!CSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 11:34'!
paddedHeightWhenPlacedAt: place
"How heigh is this morph when placed as the nth element,
along a line of elements in a command block?"

	| h |

	h _ self height.

	(self isEmptySlot not and: [place = 1]) ifTrue: [ ^ h + 10 ].
	^ h + 5.
! !


!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:02'!
ensureSlotWidth: width
"This is a special slotted block and we want to make sure of its width."

	self width: width.! !

!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:13'!
morphEndsLine
"This morph should be the only one on its line (not counting children)."

	^ true.! !

!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:13'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children)."

	^ false.! !

!CArgSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:45'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self width: linewidth - 5.! !


!OSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:16'!
paddedHeightWhenPlacedAt: place
"How heigh is this morph when placed as the nth element,
along a line of elements in a command block?"

	| h |

	h _ self height.

	(self isEmptySlot not and: [place = 1]) ifTrue: [ ^ h + 10 ].
	^ h + 5.
! !


!CReporterSlotMorph methodsFor: 'as yet unclassified' stamp: 'CWB 11/9/2012 22:03'!
ensureSlotWidth: width
"This is a special slotted block and we want to make sure of its width."

	self width: width.! !

!CReporterSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:14'!
morphEndsLine
"This morph should be the only one on its line (not counting children)."

	^ true.! !

!CReporterSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/9/2012 22:14'!
morphStartsNewLine
"This morph should be the only one on its line (not counting children)."

	^ false.! !

!CReporterSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:45'!
parentsFinalLineWidth: linewidth
	"Some morphs adjust their width when they know 
	how wide the line they are on is."

	self width: linewidth - 5.! !


!ScriptableScratchMorph methodsFor: 'blocks' stamp: 'CWB 11/9/2012 16:16'!
viewerPageForMotors
	"Answer a morph containing motor blocks for the given category for use in the given ScratchViewer."

	| bin x y configPilotButton  configMotorsButton |
	bin _ ScratchBlockPaletteMorph new.

	x _ 12.
	y _ 10.

	configPilotButton _ ScratchFrameMorph
		buttonLabel: 'Configure Pilot' localized
		selector: #showConfigurePilotDialog.
	(self isKindOf: ScratchSpriteMorph) ifTrue: [configPilotButton actionSelector: #showConfigurePilotDialog].
	bin addMorph: (configPilotButton target: self; position: x@y).
	y _ configPilotButton bottom + 5.

	configMotorsButton _ ScratchFrameMorph
		buttonLabel: 'Configure Motors' localized
		selector: #showConfigureMotorsDialog.
	(self isKindOf: ScratchSpriteMorph) ifTrue: [configMotorsButton actionSelector: #showConfigureMotorsDialog].
	bin addMorph: (configMotorsButton target: self; position: x@y).
	y _ configMotorsButton bottom + 5.


	((self blocksFor: 'motors') , (self blocksFor: 'pilot')) do: [:blockOrSym |
		(blockOrSym = #-) | (blockOrSym = #~) |  (blockOrSym = #=)
			ifTrue: [
				(blockOrSym = #-) ifTrue: [y _ y + 15].  "insert a full space"
				(blockOrSym = #~) ifTrue: [y _ y + 5].  "insert a half space"
				(blockOrSym = #=) ifTrue: [
					y _ y + 7.
					bin addMorph: ((ImageMorph new form: (ScratchFrameMorph skinAt: #connector)) position: x@y).
					y _ y + 20]]  "insert a line"
			ifFalse: [
				y _ self createBlock: blockOrSym atPosition: x@y onPage: bin]].

	^ bin
! !

CArgSlotMorph removeSelector: #paddedHeightWhenPlacedAt:!
MultiArgReporterBlockMorph removeSelector: #fixBlockLayoutWrapNew!
ReporterBlockMorph removeSelector: #fixBlockLayoutWrapNew!
MultiArgCommandBlockMorph removeSelector: #fixBlockLayoutWrapNew!
CommandBlockMorph removeSelector: #stackNestedReporterBlocks!
