ChoiceArgMorph subclass: #AttributeArgMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!

!AttributeArgMorph methodsFor: 'accessing' stamp: 'jens 4/19/2011 16:52'!
choice: aSymbol
	"Update the toggle button when an argument is changed within a block."

	| frame palette block doLocalization label target |

	(ScriptableScratchMorph new objectInterface keys includes: aSymbol)
		ifTrue: [^ self universalAttributeChoice: aSymbol].

	frame _ self ownerThatIsA: ScratchFrameMorph.
	((#soundNames = getOptionsSelector) and:
	 [aSymbol = ('record' localized, ScratchTranslator ellipsesSuffix)]) ifTrue: [
		frame ifNotNil: [^ frame newSound]].

	((#sceneNames = getOptionsSelector) and:
	 [aSymbol = ('record' localized, ScratchTranslator ellipsesSuffix)]) ifTrue: [
		frame ifNotNil: [^ frame workPane newScene]].

	((#sceneNames = getOptionsSelector) and:
	 [aSymbol = ('re-record' localized, ScratchTranslator ellipsesSuffix)]) ifTrue: [
		frame ifNotNil: [^ frame workPane rerecordScene]].

	choice _ label _ aSymbol.
	aSymbol = #null ifTrue: [
		label _ ''].

	target _ self target.
	((target isKindOf: ScriptableScratchMorph) and: [target allLocalBlockIds includes: aSymbol])
		ifTrue: [
			labelMorph isHidden: true.
			self extent: (target lambda: aSymbol) imageForm extent + (14@2)]
		ifFalse: [
			labelMorph isHidden: false.
			label isUnicode ifFalse: [label _ label asString].
			doLocalization _ (#(costumeNames soundNames varNamesMenu listVarMenu) includes: getOptionsSelector) not.
			doLocalization & label isUnicode not
				ifTrue:[labelMorph contents: label localized]
				ifFalse:[labelMorph contents: label].
			labelMorph position: self position + borderWidth + (3 @ -1).
			self extent: (labelMorph extent + (16@2) + borderWidth) ].

	menuIconMorph position: (self right - borderWidth - 10)@(self top + borderWidth + 4).

	(owner isKindOf: BlockMorph) ifTrue: [
		(owner respondsTo: #addLabel)
			ifTrue: [owner addLabel]
			ifFalse: [owner fixBlockLayout]].

	(palette _ self ownerThatIsA: ScratchBlockPaletteMorph) ifNil: [^ self].
	(block _ self ownerThatIsA: BlockMorph) ifNil: [^ self].

	block isReporter ifTrue: [palette updateWatcherButtonsForFrame: frame].
! !

!AttributeArgMorph methodsFor: 'accessing' stamp: 'jens 1/24/2011 21:46'!
drawOn: aCanvas

	| target |
	super drawOn: aCanvas.
	self isBYOBattributeArg
		ifTrue: [^ self].
	target _ self target.
	(target respondsTo: #allLocalBlockIds)
		ifFalse: [^ self ].
	(target allLocalBlockIds includes: choice)
		ifFalse: [^self ]
		ifTrue: [
			aCanvas paintImage: (target lambda: choice) imageForm at: self position + (1@1) ]! !

!AttributeArgMorph methodsFor: 'accessing' stamp: 'jens 2/14/2011 22:03'!
options
	"Answer my set of attributes."

	| target list blockIds |
	((owner isKindOf: CommandBlockMorph) and:
	 [owner selector = #getAttribute:of:]) ifFalse: [^ #()].

	((owner argumentAt: 2) isKindOf: SpriteArgMorph)
		ifFalse: [^ #()].

	(target _ (owner argumentAt: 2) evaluate) ifNil: [^ #()].
	(target isKindOf: ScriptableScratchMorph) ifFalse: [^ #()].
	target varNames size > 0
		ifTrue: [list _ target attributeNames, #(-), target varNames]
		ifFalse: [list _ target attributeNames].
	blockIds _ target allLocalBlockIds.
	blockIds isEmpty ifFalse: [
		list _ list,  #(-), blockIds ].
	^ list
! !

!AttributeArgMorph methodsFor: 'accessing' stamp: 'CWB 9/10/2012 20:00'!
presentMenu
	"Pop up a menu of choices."

	| optionList doLocalization menu selection option target blockIds |
	self isBYOBattributeArg
		ifTrue: [^ self presentAttributesMenu].

	"optionList _ #(''), self options."	"Not sure why BYOB adds a blank element at the start"
	optionList _ self options.

	optionList size = 0 ifTrue: [^ self].
	doLocalization _ (#(costumeNames soundNames varNamesMenu listVarMenu) includes: getOptionsSelector) not.
	menu _ CustomMenu new.
	target _ self target.
	target ifNil: [^ self].
	blockIds _ target allLocalBlockIds.
	optionList do: [:sym |
		'-' = sym
			ifTrue: [menu addLine]
			ifFalse: [
				doLocalization & sym isUnicode not
					ifTrue: [option _ sym localized asUTF8]
					ifFalse: [option _ sym].
				((#(hookupSensorNames hookupBooleanSensorNames) includes: getOptionsSelector) and:
				 [(#(connected resistance) includes: sym)])
					ifTrue: [#(A B C D) do: [:c |
						self owner isBooleanReporter
							ifFalse: [menu add: (option, '-', c) action: (sym, '-', c)]
							ifTrue: [menu add: (c asUTF8, ' ', option) action: (c, ' ' ,sym)]]]
					ifFalse: [ 
						(blockIds includes: sym)
							ifTrue: [ menu addIcon: (target lambda: sym) imageForm
										toolTip: nil
										action: sym ]
							ifFalse: [menu add: (UTF8 withAll: option) asMacRoman action: sym]]]].
	(selection _ menu startUp) ifNotNil: [self choice: selection].! !

!AttributeArgMorph methodsFor: 'accessing' stamp: 'jens 2/14/2011 22:11'!
target
	owner ifNil: [^nil].
	(#(attribute:of: get: set:to:) includes: owner selector)
		ifTrue: [^ nil].

	owner selector = #getAttribute:of: ifTrue: [
		((owner argumentAt: 2) isKindOf: SpriteArgMorph) ifFalse: [
			^ nil]].

	^(owner argumentAt: 2) evaluate.
! !


!AttributeArgMorph methodsFor: 'BYOB' stamp: 'jens 2/4/2011 01:00'!
isBYOBattributeArg
	^ (owner isKindOf: CommandBlockMorph) and:
	 [#(attribute:of: get: set:to:) includes: owner selector]
! !

!AttributeArgMorph methodsFor: 'BYOB' stamp: 'jens 2/4/2011 01:12'!
presentAttributesMenu
	"Pop up a menu of built-in choices for every sprite/stage object."

	| optionList menu selection option advancedOptions |

	(#(get: set:to:) includes: owner selector) ifTrue: [
		^ self presentUniversalAttributesMenu].

	optionList _ #('x position' 'y position' 'direction' 'costume #' 'size' 'volume').
	menu _ CustomMenu new.
	optionList do: [:sym |
		sym isUnicode not
			ifTrue: [option _ sym localized asUTF8]
			ifFalse: [option _ sym].
		menu add: (UTF8 withAll: option) asMacRoman action: sym].

	menu addLine.
	advancedOptions _  #('name' 'prototype' 'owner' 'parts').
	advancedOptions do: [:sym |
		sym isUnicode not
			ifTrue: [option _ sym localized asUTF8]
			ifFalse: [option _ sym].
		menu add: (UTF8 withAll: option) asMacRoman action: sym].

	(selection _ menu startUp) ifNotNil: [self choice: selection].! !

!AttributeArgMorph methodsFor: 'BYOB' stamp: 'jens 4/19/2011 15:10'!
presentUniversalAttributesMenu
	"Pop up a menu of built-in choices for every sprite/stage object."

	| oi menu entry option selection catz actions pairs val |

	catz _ #(sprite motion looks effects sound pen relationship).
	oi _ owner receiver objectInterface.
	actions _ Dictionary new.

	catz do: [:cat |
		pairs _ OrderedCollection new.
		oi keysDo: [:key |
			val _ oi at: key.
			val first = cat ifTrue: [
				pairs add: {val fourth. key}]].
		actions at: cat put: (pairs asSortedCollection:[:x :y |
					x first <= y first])].

	menu _ CustomMenu new.

	"first, add empty slot"
	menu add: '' action: #null.	

	catz do: [:cat |
		cat = catz first ifFalse: [
			menu addLine].
		(actions at: cat) do: [:tuple |
			entry _ tuple first.
			entry isUnicode not
				ifTrue: [option _ entry localized asUTF8]
				ifFalse: [option _ entry].
			menu add: (UTF8 withAll: option) asMacRoman action: tuple second]].
		
	(selection _ menu startUp) ifNotNil: [self universalAttributeChoice: selection].! !

!AttributeArgMorph methodsFor: 'BYOB' stamp: 'jens 3/3/2010 16:21'!
refresh
	self choice: choice! !

!AttributeArgMorph methodsFor: 'BYOB' stamp: 'jens 4/19/2011 15:26'!
universalAttributeChoice: aSymbol
	"Update the toggle button when an argument is changed within a block."

	| oi frame palette block label |
	frame _ self ownerThatIsA: ScratchFrameMorph.
	oi _ owner receiver objectInterface.

	choice _ aSymbol.
	choice = #null
		ifTrue: [label _ '']
		ifFalse: [label _ (oi at: aSymbol) fourth].

	labelMorph isHidden: false.
	label isUnicode ifFalse: [label _ label asString].
	label isUnicode not
		ifTrue:[labelMorph contents: label localized]
		ifFalse:[labelMorph contents: label].
	labelMorph position: self position + borderWidth + (3 @ -1).
	self extent: (labelMorph extent + (16@2) + borderWidth).

	menuIconMorph position: (self right - borderWidth - 10)@(self top + borderWidth + 4).

	(owner isKindOf: BlockMorph) ifTrue: [
		(owner respondsTo: #addLabel)
			ifTrue: [owner addLabel]
			ifFalse: [owner fixBlockLayout]].

	(palette _ self ownerThatIsA: ScratchBlockPaletteMorph) ifNil: [^ self].
	(block _ self ownerThatIsA: BlockMorph) ifNil: [^ self].

	block isReporter ifTrue: [palette updateWatcherButtonsForFrame: frame].
! !
