ReporterScriptBlockMorph subclass: #OSlotMorph
	instanceVariableNames: 'implicitValue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 23:28'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	^ aBlockMorph isReporter! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
defaultValue: default
	"do nothing"! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
evaluate

	implicitValue notNil
		ifTrue: [^implicitValue].
	^ super evaluate! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
evaluateWithArgs: rawArgs

	implicitValue notNil
		ifTrue: [^implicitValue].
	^super evaluateWithArgs: rawArgs! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
fixArgLayout
	"Fix my layout. This default implementation does nothing."! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:56'!
implicitValue
	^ implicitValue! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:57'!
implicitValue: anObject
	implicitValue _ anObject! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:58'!
isEmptySlot
	^ self body isNil! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 3/23/2010 21:55'!
isKindOf: aClass
	aClass = ArgMorph 
		ifTrue: [^ true].
	^ super isKindOf: aClass
! !

!OSlotMorph methodsFor: 'argument slot behavior' stamp: 'jens 6/22/2010 20:29'!
isLambdaForm
	^ false! !


!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/23/2010 21:54'!
handlesMouseDown: evt

	^false! !

!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 16:13'!
initialize
	super initialize.
	isSpecialForm _ true.
	minArgs _ 0.
	maxArgs _ 0.
"	self type: #reporterslot."
	removeElementMorph ifNotNil: [
		removeElementMorph delete]! !

!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 4/7/2010 00:07'!
receiver

	^receiver ifNil: [
		(owner respondsTo: #receiver)
			ifTrue: [^receiver _ owner receiver]
			ifFalse: [^nil]]	! !

!OSlotMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 16:06'!
type: aSymbol

	type _ aSymbol.

	#reporterslot = type ifTrue: [
		selector _ #autoBlock.
		self commandSpec: '%Z'].

	#booleanslot = type ifTrue: [
		selector _ #autoPredicate.
		self commandSpec: '%Y'].

	self addLabel.

	removeElementMorph ifNotNil: [
		removeElementMorph delete]
! !


!OSlotMorph methodsFor: 'drawing' stamp: 'jens 5/19/2010 04:08'!
drawOn: aCanvas 

	(owner respondsTo: #color) ifTrue: [
		color = owner color ifFalse: [
			color _ owner color]].

	self nestedBlock ifNil: [
		aCanvas
			fillRectangle: self bounds color: color].

	self drawSlotOn: aCanvas! !

!OSlotMorph methodsFor: 'drawing' stamp: 'jens 4/14/2010 00:33'!
drawSlotOn: aCanvas

	| dark |

	(type = #booleanslot and: [argMorphs first isKindOf: SpecialArgMorph])
		ifTrue: [^ self].

	dark _ Color gray " (color mixed: 0.45 with: Color darkGray)". 

	(argMorphs first isKindOf: ReporterBlockMorph) ifTrue: [
		argMorphs first isBooleanReporter
			ifTrue: [
				aCanvas paintImage: ((argMorphs first imageForm withOutlineColor: dark width: 4) 
					withHalfEmbeddedOutlineColor: dark)
					at: (argMorphs first position - 5).
				^self ]
			ifFalse: [
				aCanvas paintImage: ((argMorphs first imageForm withOutlineColor: dark width: 4) 
					"withHalfEmbeddedOutlineColor: dark)"
					withEmbeddedOutlineColor: dark width: 1)
					at: (argMorphs first position - 5).
				^self ]].

	aCanvas paintImage: (argMorphs first imageForm outlineEmbeddedAdjustedColor: dark) 
		at: (argMorphs first position - 1)

! !


!OSlotMorph methodsFor: 'stack/tuple conversion' stamp: 'jens 7/7/2010 01:07'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg |
	
	blockTuple _ Array new: 4.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector.

	arg _ self nestedBlock.
	(arg isKindOf: ReporterBlockMorph)
		ifTrue: [blockTuple at: 4 put: (Array with: argMorphs first asBlockTuple)]
		ifFalse: [blockTuple at: 4 put: nil]. 
	^ blockTuple! !


!OSlotMorph methodsFor: 'geometry' stamp: 'CWB 11/12/2012 10:16'!
paddedHeightWhenPlacedAt: place
"How heigh is this morph when placed as the nth element,
along a line of elements in a command block?"

	| h |

	h _ self height.

	(self isEmptySlot not and: [place = 1]) ifTrue: [ ^ h + 10 ].
	^ h + 5.
! !
